io.stdout:setvbuf("no")
require "util"
love.keyboard.setTextInput(false)

local delay = require "delay"
local player = require "player"
local timbre = require "timbre"
local midi = require "midiCtrl"
local game = require "game"

local speed = 0.5
local rate = 10
collectgarbage("stop")
function love.load()
    timbre:init()
    player:setMainNote(timbre:getMainNote())
    mario = midi:new(player,"sm3.mid")
    game:init(midi:new(nil,"sm3.mid"),rate,speed)
    delay:new(speed,function() mario:play() end)
end


function love.update(dt)
    delay:update(dt)
    player:update(dt)
    timbre:update()
    mario:update(dt)
    game:update(dt)
end

function love.draw()
    
    player:draw()
    timbre:draw()
    game:draw()
    love.graphics.print(love.timer.getFPS())
end

function love.keypressed(key)
    if key == "space" then
        player:setMainNote(timbre:getMainNote())
    end
    --player:keypressed(key)
    game:readKey(key)
end



